(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: translmod.mli,v 1.1.1.1 1998/04/20 11:32:11 lefessan Exp $ *)

(* Translation from typed abstract syntax to lambda terms,
   for the module language *)

open Typedtree
open Lambda

val transl_implementation: string -> structure -> module_coercion -> lambda
val transl_store_implementation:
      string -> structure -> module_coercion -> int * lambda

val transl_toplevel_definition: Ident.t -> (Ident.t -> int) ->structure -> lambda

val primitive_declarations: string list ref


val mixte_interface: string -> lambda
