#include "mlvalues.h"
#include "minor_gc.h"
#include "roots.h"
#include "alloc.h"
#include "fail.h"
#include "io.h"
#include "gc.h"
#include "memory.h"
#include "signals.h"
#include "stacks.h"
#define caml_generated_constant value
#include "common.h"

int with_native = 0;

caml_generated_constant  Out_of_memory, Sys_error, Failure,
  Invalid_argument, End_of_file, Division_by_zero, Not_found, 
  Match_failure;

char * static_data_start = NULL;
char * static_data_end = NULL;
char *code_area_start = NULL;
char *code_area_end = NULL;

void asm_oldify_local_roots (void)
{}

void asm_do_roots (scanning_action f)
{}

void asm_caml_main(char **argv)
{
  in_bytecode = 1;
  byte_caml_main(argv);
}

value asm_callback(value closure, value arg)
{
  invalid_argument("Callback to native closure in bytecode program");
  return Val_unit;
}
value asm_callback2(value closure, value arg1, value arg2)
{  
  invalid_argument("Callback to native closure in bytecode program");
  return Val_unit;
}
value asm_callback3(value closure, value arg1, value arg2,
		     value arg3)
{  
  invalid_argument("Callback to native closure in bytecode program");
  return Val_unit;
}

void asm_mlraise(value v)
{
  Assert(! async_signal_mode);
  Unlock_exn();
  exn_bucket = v;
  siglongjmp(external_raise->buf, 1);
}

void asm_failwith (char *msg)
{
  raise_with_string(Field(global_data, FAILURE_EXN), msg);
}

void asm_invalid_argument (char *msg)
{
  raise_with_string(Field(global_data, INVALID_EXN), msg);
}

static struct {
  header_t hdr;
  value exn;
} out_of_memory_bucket;

void asm_raise_out_of_memory(void)
{
  out_of_memory_bucket.hdr = Make_header(1, 0, White);
  out_of_memory_bucket.exn = Field(global_data, OUT_OF_MEMORY_EXN);
  mlraise((value) &(out_of_memory_bucket.exn));
}

void asm_raise_stack_overflow(void)
{
  raise_constant(Field(global_data, STACK_OVERFLOW_EXN));
}

void asm_raise_sys_error(value msg)
{
  raise_with_arg(Field(global_data, SYS_ERROR_EXN), msg);
}

void asm_raise_end_of_file(void)
{
  raise_constant(Field(global_data, END_OF_FILE_EXN));
}

void asm_raise_zero_divide(void)
{
  raise_constant(Field(global_data, ZERO_DIVIDE_EXN));
}

void asm_raise_not_found(void)
{
  raise_constant(Field(global_data, NOT_FOUND_EXN));
}

