#ifndef COMMON_H
#define COMMON_H

#include "roots.h"

/* The globals holding predefined exceptions */

#ifndef caml_generated_constant
typedef char caml_generated_constant[256];
/* We claim these constants are big so that e.g. the Mips compiler
   will not assume that they are in the .sdata section */

extern caml_generated_constant Out_of_memory, Sys_error, Failure,
  Invalid_argument, End_of_file, Division_by_zero, Not_found, 
  Match_failure;
#endif

extern value mixte_callback(value f,value arg);/* mixte.c */

extern void byte_oldify_local_roots (void);
extern void asm_oldify_local_roots (void);
extern void asm_do_roots (scanning_action);
extern void byte_do_roots (scanning_action);
extern void asm_caml_main(char**);
extern void byte_caml_main(char**);
extern value asm_callback(value closure, value arg);
extern value asm_callback2(value closure, value arg1,value arg2);
extern value asm_callback3(value closure, value arg1,value arg2,value arg3);
extern value byte_callback(value closure, value arg);
extern value byte_callback2(value closure, value arg1,value arg2);
extern value byte_callback3(value closure, value arg1,value arg2,value arg3);
extern void asm_caml_main(char**);
extern void byte_caml_main(char**);

extern void init_ieee_floats(); /* floats.c */
extern int parse_command_line(char **argv); /* startup.c */

extern int in_bytecode;
extern int with_native;
extern int with_bytecode;
extern int trace_flag;

extern void asm_raise_not_found(void) Noreturn ; 
extern void asm_raise_zero_divide(void) Noreturn ;
extern void asm_raise_end_of_file(void) Noreturn ;
extern void asm_raise_sys_error(value msg) Noreturn ;
extern void asm_raise_out_of_memory(void) Noreturn ;
extern void asm_failwith (char *msg) Noreturn ;
extern void asm_invalid_argument (char *msg) Noreturn ;
extern void asm_mlraise(value v) Noreturn ;
extern void asm_raise_stack_overflow(void) Noreturn ;

extern void byte_raise_not_found(void) Noreturn ;
extern void byte_raise_zero_divide(void) Noreturn ;
extern void byte_raise_end_of_file(void) Noreturn ;
extern void byte_raise_sys_error(value msg) Noreturn ;
extern void byte_raise_out_of_memory(void) Noreturn ;
extern void byte_failwith (char *msg) Noreturn ;
extern void byte_invalid_argument (char *msg) Noreturn ;
extern void byte_mlraise(value v) Noreturn ;
extern void byte_raise_stack_overflow(void) Noreturn;

extern void mixte_init(void);


#endif
