/***********************************************************************/
/*                                                                     */
/*                           Objective Caml                            */
/*                                                                     */
/*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         */
/*                                                                     */
/*  Copyright 1996 Institut National de Recherche en Informatique et   */
/*  Automatique.  Distributed only by permission.                      */
/*                                                                     */
/***********************************************************************/

/* $Id: instruct.h,v 1.1.1.1 1998/04/20 11:32:11 lefessan Exp $ */

/* The instruction set. */

enum instructions {
  ACC0, ACC1, ACC2, ACC3, ACC4, ACC5, ACC6, ACC7,
  ACC, PUSH,
  PUSHACC0, PUSHACC1, PUSHACC2, PUSHACC3,
  PUSHACC4, PUSHACC5, PUSHACC6, PUSHACC7,
  PUSHACC, POP, ASSIGN,
  ENVACC1, ENVACC2, ENVACC3, ENVACC4, ENVACC,
  PUSHENVACC1, PUSHENVACC2, PUSHENVACC3, PUSHENVACC4, PUSHENVACC,
  PUSH_RETADDR, APPLY, APPLY1, APPLY2, APPLY3,
  APPTERM, APPTERM1, APPTERM2, APPTERM3, 
  RETURN, RESTART, GRAB,
  CLOSURE, CLOSUREREC,
  GETGLOBAL, PUSHGETGLOBAL, GETGLOBALFIELD, PUSHGETGLOBALFIELD, SETGLOBAL,
  ATOM0, ATOM, PUSHATOM0, PUSHATOM,
  MAKEBLOCK, MAKEBLOCK1, MAKEBLOCK2, MAKEBLOCK3,
  GETFIELD0, GETFIELD1, GETFIELD2, GETFIELD3, GETFIELD,
  SETFIELD0, SETFIELD1, SETFIELD2, SETFIELD3, SETFIELD,
  DUMMY, UPDATE,
  VECTLENGTH, GETVECTITEM, SETVECTITEM,
  GETSTRINGCHAR, SETSTRINGCHAR, 
  BRANCH, BRANCHIF, BRANCHIFNOT, SWITCH, BOOLNOT,
  PUSHTRAP, POPTRAP, RAISE, CHECK_SIGNALS,
  C_CALL1, C_CALL2, C_CALL3, C_CALL4, C_CALL5, C_CALLN,
  CONST0, CONST1, CONST2, CONST3, CONSTINT,
  PUSHCONST0, PUSHCONST1, PUSHCONST2, PUSHCONST3, PUSHCONSTINT,
  NEGINT, ADDINT, SUBINT, MULINT, DIVINT, MODINT,
  ANDINT, ORINT, XORINT, LSLINT, LSRINT, ASRINT,
  EQ, NEQ, LTINT, LEINT, GTINT, GEINT,
  OFFSETINT, OFFSETREF,
  GETMETHOD, GETANCMETHOD,
  NOP,
  PUSHGETGLOBALFIELDAPPLY,
  PUSHGETGLOBALFIELDAPPLY1,
  PUSHGETGLOBALFIELDAPPLY2,
  PUSHGETGLOBALFIELDAPPLY3,
  PUSHGETGLOBALFIELDAPPLY_UNRESOLVED,
  PUSHGETGLOBALFIELDAPPLY1_UNRESOLVED,
  PUSHGETGLOBALFIELDAPPLY2_UNRESOLVED,
  PUSHGETGLOBALFIELDAPPLY3_UNRESOLVED, 
  PUSHGETGLOBALFIELDAPPTERM,
  PUSHGETGLOBALFIELDAPPTERM1,
  PUSHGETGLOBALFIELDAPPTERM2,
  PUSHGETGLOBALFIELDAPPTERM3,
  PUSHGETGLOBALFIELDAPPTERM_UNRESOLVED,
  PUSHGETGLOBALFIELDAPPTERM1_UNRESOLVED,
  PUSHGETGLOBALFIELDAPPTERM2_UNRESOLVED,
  PUSHGETGLOBALFIELDAPPTERM3_UNRESOLVED,
  GETGLOBAL_UNRESOLVED, PUSHGETGLOBAL_UNRESOLVED,
  GETGLOBALFIELD_UNRESOLVED, PUSHGETGLOBALFIELD_UNRESOLVED,
  C_CALL1_UNRESOLVED, C_CALL2_UNRESOLVED, C_CALL3_UNRESOLVED,
  C_CALL4_UNRESOLVED, C_CALL5_UNRESOLVED, C_CALLN_UNRESOLVED,
  GETMETHOD_UNRESOLVED,
  SETMODULE, SETLOCAL,
  BEGINMODULE,  GETLOCAL, PUSHGETLOCAL, REPLACECODEPTR, 
  CODEPTR, THISMODULE,
  STOP, EVENT, BREAK
};
