#include "mlvalues.h"
#include "callback.h"
#include "common.h"
#include "fail.h"

value is_mixte_value(value v) /* ML */
{
  if(Is_block (v) && (Tag_val(v) == Closure_byte_tag || Tag_val(v) == Closure_asm_tag))
    return Val_false;
  return Val_true;
}

extern char **main_argv;
value mixte_byte_start(value unit) /* ML */
{
  int old_code = in_bytecode;

  in_bytecode = 1;
  byte_caml_main(main_argv);
  in_bytecode = old_code;
  return Val_unit;
}

value c_import_module(value name) /* ML */
{
  value *res;
  
  res = caml_named_value(String_val(name));
  if(res == NULL)
    failwith("Module not registered");
  else
    return *res;
}
value asm_callback_arg_asm= (value) NULL;
value asm_callback_arg_byte= (value) NULL;
value byte_callback_arg_asm= (value) NULL;
value byte_callback_arg_byte= (value) NULL;

value mixte_callback(value f,value arg) /* ML */
{
  int old_code = in_bytecode;
  value res;

  if(Tag_val(f) == Closure_byte_tag){
    in_bytecode = 1;
    if(Is_block (arg) && Tag_val(arg) == Closure_asm_tag){
      res = callback2(byte_callback_arg_asm,f,arg);
    } else {
      res = callback2(byte_callback_arg_byte,f,arg);
    }
  } else {
    in_bytecode = 0;
    if(Is_block (arg) && Tag_val(arg) == Closure_byte_tag){
      res = callback2(asm_callback_arg_byte,f,arg);
    }else{
      res = callback2(asm_callback_arg_asm,f,arg);
    }
  }
  in_bytecode = old_code;
  return res;
}

value mixte_register(value cllbck,value cllwrp) /* ML */
{
  if(Tag_val(cllbck) == Closure_byte_tag){
    byte_callback_arg_asm = cllwrp;
    byte_callback_arg_byte = cllbck;
    register_global_root(&byte_callback_arg_asm);
    register_global_root(&byte_callback_arg_byte);
  } else {
    asm_callback_arg_asm = cllbck;
    asm_callback_arg_byte = cllwrp;
    register_global_root(&asm_callback_arg_asm);
    register_global_root(&asm_callback_arg_byte);
  }
  return Val_unit;
}

#include <stdio.h>
void mixte_init(void)
{

  /* un probleme d'incompatibilite entre les exceptions natives et
  bytecode ...
  
  if(with_native && with_bytecode){
    fprintf(stderr,"Mixte init\n");
    Modify(&Field(global_data, FAILURE_EXN), (value)Failure);
    Modify(&Field(global_data, OUT_OF_MEMORY_EXN), (value)Out_of_memory);
    Modify(&Field(global_data, SYS_ERROR_EXN), (value)Sys_error);
    Modify(&Field(global_data, END_OF_FILE_EXN), (value)End_of_file);
    Modify(&Field(global_data, ZERO_DIVIDE_EXN), (value)Division_by_zero);
    Modify(&Field(global_data, NOT_FOUND_EXN),  (value)Not_found);
  }

  On n'essaie pas d'unifier les exceptions predefinies ici. On peut aussi
  le faire dans asm et byte_callback ...
  */
}
