#ifndef MODULES_H
#define MODULES_H

/*

Chaque module commence par executer :
  BEGINMODULE initial_data

Initial data:
0 --> name:string
1 --> module_slot:int
2 --> offset: int
3 --> longueur: int
4 --> begin_code: Obj.t
5 --> end_code: Obj.t
6 --> reloc: int array
7 --> bytecode: string

*/

/* Also defined in join.ml */
/* Slots INTERFACE(8) and EXCEPTIONS(9) are also defined in 
   bytecomp/translmod.ml */
#define MODULE_NAME 0
#define MODULE_SLOT 1
#define OFFSET      2
#define LONGUEUR    3
#define _BEGIN_CODE  4
#define _END_CODE    5
#define RELOC       6
#define BYTECODE    7
#define INTERFACE   8
#define CLASSES     9
#define MIGRATE     10
#define EXCEPTIONS  11
#define MODULE_DATA_SIZE 12

extern value module_table;

extern void init_modules(void);
extern void begin_module(code_t begin_code, value initial_data);
extern void resolv_module(code_t pc,int32 opcode,int offset);
extern void resolv_prim(code_t pc,int32 opcode,int offset);
extern value resolv_method(code_t pc);
extern code_t resolv_codeptr(code_t pc);
extern value find_code_ptr (code_t f,int32 *offset);
extern value install_module(value initial_data,value module);
#ifdef THREADED_CODE
#define THREADED(opcode)  ((opcode_t)(instr_table[opcode] - instr_base))
#else
#define  THREADED(opcode) opcode
#endif

#endif

extern void good_stub(value,char*,char*,int);
extern void failed_message(char *msg,char * expr,char *file, int line);


#ifdef DEBUG
#define Good_stub(msg,stub) good_stub(stub,msg, __FILE__, __LINE__)
#else
#define Good_stub(msg,stub)
#endif
