(* philo.ml: some philosophers at dinner *)


let sleep n = 
  for i=0 to n*1000 do
    ()
  done

let def decr! () | state n = state (n-1) | reply n
let _ = spawn {state 10000}

let def new_fork! () = 
  let def grab! () | free() =  busy () | reply true
  or  grab! () | busy() =  busy () | reply false
  or  drop() | busy() =  free ()
  in  free () | reply (grab, drop)

let def philosopher (name, grab_l, drop_l, grab_r, drop_r) = 
  let def think() = 
    hungry ()
  or hungry() =  
    if grab_l () then
      if grab_r () then
        eat ()
      else 
      {  drop_l () | think () }
    else
      think ()
  or eat() =  
    if decr () > 0 then
      {      
        think () | drop_l () | drop_r ()
    } 
    else
      {drop_l () | drop_r ()}
  in think ()
  ;;

				
spawn { 
  let grab_f1,drop_f1 = new_fork ()
  and grab_f2,drop_f2 = new_fork ()
  and grab_f3, drop_f3 = new_fork ()
  in
  philosopher ("Platone", grab_f1, drop_f1, grab_f2, drop_f2) |
  philosopher ("Socrate", grab_f2, drop_f2, grab_f3, drop_f3) |
  philosopher ("Aristotele", grab_f3, drop_f3, grab_f1, drop_f1)
} 

;;

