(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* Some concurrent object-oriented priority queue *) 

let def min! (x,y) = reply if x < y then x else y 
let def max! (x,y) = reply if x > y then x else y 

let def create! () =

  let def empty ! () | none () =
    none () | reply true
  or  empty! () | some (x,e,a,r) =
    some (x,e,a,r) | reply false
  or  add! (x)  | none () =
    { let e,a,r = create () in some (x,e,a,r) } | reply ()
  or  add! (x)  | some (y,e,a,r) =
    { let s =  max (x,y) in
      a (s);
      let min = min (x,y) in
       some ( min,e,a,r ) } | reply ()
  or  remove! ( ) | some (x,e,a,r) =
   { if e () then none () else some (r (),e,a,r ) } |
     reply x
in
  none () | reply (empty,add,remove)

let empty,add,remove = create ()

let limite = 400

let _ = 
  for i = 1 to limite do
    add  ( (i * 33877) mod 1000 )
  done;
  for i = 1 to limite do
    remove ()
  done

;;
