(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Graphics

let _ = open_graph (" 600x600")

let sx = size_x ()
let sy = size_y ()

let _ = set_font("-*-times-bold-r-*-*-20-*-*-*-*-*-*-*")

let def print_name! (i,j,w,h,name,color) =
  Debug.print ("name of window "^name);
  (let wt,ht = text_size(name) in
  if color <> black then (
    set_color(black) ;      
    fill_rect (i+2) (j+h/2-2) (wt+4) (ht+4)
      );
  set_color(color) ;
  moveto (i+4) (j+h/2-4) ;
  draw_string(name) );
  print_string ("Client : "^name);
  print_newline();
    reply ()
;;

let def draw_square! (name,i,j,w,h,data)  =
  {
  Debug.print ("----------) "^name);
  Draw.quad data i j w h Calc.limit ;
  print_name (i,j,w,h,name,white);} |
  reply  to draw_square

let definition () =
  let def declare(a) | decl_in_loc ! () = reply a
  in 
     (declare,decl_in_loc)

let def make_comp ! (there,killover) =
  let (declare,decl_in_loc) = definition () in
  let loc mandel struct
    let def square! (i0,j0,w,h) =
      reply (Calc.compute i0 j0 w h sx sy) to square
  and kill () = print_string("Here I die") ; print_newline () ; killover ()
  ;;
  print_string("Here I go") ; print_newline () ;
  Join.go there  ; print_string("Here I am") ; print_newline () ;
  spawn { Debug.print "declare" ; declare ((square,kill))}
end in
  reply (decl_in_loc ())

let w = 100 and h = 100 (* true sizes *)

let def s(n,m) | next(name,job,kill) =
  if m + Calc.pixel > sy then  { s (n+w,0) |  next (name,job,kill) }
  else if n+Calc.pixel > sx then  { kill () | killAll () }
  else  {
      { Debug.print "s" ; s (n,m+h) } |
      let w = min w (sx-n) and h = min h (sy-m) in
      print_name (n,m,w,h,name,black) ;
      let r = job (n/Calc.pixel,m/Calc.pixel,w/Calc.pixel,h/Calc.pixel) in
      Debug.print ("draw square:"^name);
      draw_square (name,n,m,w,h,r);
      Debug.print ("next name:"^name);
    next (name,job,kill)
} 
or killAll() | next(name,job,kill) = killAll () | kill () 

let def register_me(local,kill,name) =
  Debug.print "<";
  Debug.print ("client on "^name);
  Debug.print ">";
  let name =
   if String.length(name) > 8 then
     String.sub name 0 8
   else name in
  let job,kill = make_comp (local,kill) in
   Debug.print ("next_name "^name) ; next (name,job,kill)

let _ = 
  Join.setLocalService "register_me" register_me vartype;
  spawn { Debug.print "s" ; s (0,0) }

let _ = 
  Join.server ();
  Nfs.register "mandel-opt"
 
    
