(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)


let mandel ca cb limit =
  let rec do_rec x y n =
    if n <= 0 then limit
    else
      let ny = 2.0 *. x *. y +. cb
      and nx = x *. x -. y *. y +. ca in
      if nx *. nx +. ny *. ny > 4.0 then limit-n
      else do_rec nx ny (n-1) in
  do_rec 0.0 0.0 limit
