(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Graphics
open Quad
open Color

let quad (t,_,_) i j w h max =
  let rec do_rec (i,j) (w,h) = function
    Leaf c ->
      let c = Color.get c max in
(*
      print_string ("fill "^string_of_int i^" "^
        string_of_int j^" "^
        string_of_int w^" "^
        string_of_int h) ;
      print_newline () ;
*)
      set_color c ;
      fill_rect i j w h
  | Nodex c ->
      do_rec (i,j) (w/2,h) c.left ;
      do_rec (i+w/2,j) (w-w/2,h) c.right
  | Nodey c ->
      do_rec (i,j) (w,h/2) c.left ;
      do_rec (i,j+h/2) (w,h-h/2) c.right in
  do_rec (i,j) (w,h) !t;

