open Join
open ThreadUnix

let name = "replicated-integer"
let arg = Sys.argv.(1)
let first = (arg = "1")

let def request_member! update | coordinator (i,n,members) =
  reply (i,n,remove_coordinator) | coordinator (i,n,update::members)

or  request_member! update | coordinated(i,n,request_coordinator) =
  let (i,n,members) = request_coordinator (remove_coordinator)
  in
  coordinator (i,n,update::members)  | reply (i,n,remove_coordinator)

or update(i',n') | coordinator(i,n,members) = coordinator (i,n,members)
  
or incr ! () | coordinator(i,n,members) = 
  let i = i + 1 in
  let n = n + 1 in
  { 
    { List.iter
        (fun update -> spawn { update (i,n) } ) members;}
    |   coordinator (i,n,members)
    | reply i
  } 

or incr ! () | coordinated(i,n,request_coordinator) =
  let (i,n,members) = request_coordinator (remove_coordinator)
  in
  let i = i + 1 in
  let n = n + 1 in
  { 
  { List.iter
      (fun update -> spawn { update (i,n) } ) members; } 
   | coordinator (i,n,members)
   | reply i
  } 

or coordinated(i,n,request_coordinator) | update(i',n') =
  if n'>n then coordinated (i',n',request_coordinator)
   else coordinated (i,n,request_coordinator)
   
or remove_coordinator! (request_coordinator) | coordinator(i,n,members) = 
    {
    reply (i,n,members) |
    coordinated (i,n,request_coordinator)
    }

or remove_coordinator! (request_coordinator') | 
  coordinated(i,n,request_coordinator) =
   { let (i,n,members) = request_coordinator (request_coordinator')
     in
       coordinated (i,n,request_coordinator') | reply (i,n,members)}


let _ =
  if first then
    begin
      spawn { coordinator (0,1,[update]) }
    end
  else
    begin
      let server = Nfs.query name in
      let request_member = Join.getRemoteService server name vartype in
      let (i,n,request_coordinator) = request_member (update) in
      spawn { coordinated (i,n,request_coordinator) }
    end;
  Join.setLocalService name request_member vartype;
  Nfs.register name;
  Join.server ();
  for i = 0 to 100 do
    for j = 0 to 1000 do
      incr ()
    done;
    printnl_int (incr ());
    Thread.delay 1.0;
  done
