(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* computes fibonacci in a inefficient way *)

let fib (x) =
  reply if x <= 1 then 1 else fib(x-1) + fib(x-2)

(* computes fibonnaci in a slighty better way (tail-recursion) *)

let better_fib(n) = 
  let fib2(n) = 
    if n <= 1 then {reply 1,1 to fib2}
    else {let x,y = fib2(n-1) in reply x+y,x to fib2} in
  let x,y = fib2(n) in
  reply x to better_fib

(* prints two equal numbers *)

do
  print(fib(26)); 
  print_string(" "); 
  print(better_fib(26))



(*
babyduck:

121393 121393
real   6.5
user   6.4
sys    0.0
*)

