(* philo.ml: some philosophers at dinner					*)

let sleep (n) =	
  if n <= 0 then reply
  else {sleep(n-1) ; reply}
;;

let rand(n) = reply n
;;

let	new_fork() = {
		let	grab() | free() = { busy() | reply true to grab} and
			grab() | busy() = { busy() | reply false to grab} and
			drop() | busy() = { free() }
		in	free() | reply grab, drop
	}
;;

let	philosopher(name, grab_l, drop_l, grab_r, drop_r) = {
		let	think() = {
				print_string("Thinking: ");
				print_string(name);
				print_string("\n");
				sleep(rand(4));
				hungry()
			} and hungry() = {
				if grab_l() then {
					if grab_r() then {
						eat()
					} else {
						drop_l() | think()
					}
				} else {
					think()
				}
			}and  eat() = {
				print_string("Eating: ");
				print_string(name);
				print_string("\n");
				sleep(rand(4));
				{ think() | drop_l() | drop_r() }
			}
		in	think()
	}
;;

				
spawn let grab_f1,drop_f1 = new_fork()
      and grab_f2,drop_f2 = new_fork()
      and grab_f3, drop_f3 = new_fork()
in
	philosopher("Platone", grab_f1, drop_f1, grab_f2, drop_f2) |
	philosopher("Socrate", grab_f2, drop_f2, grab_f3, drop_f3) |
	philosopher("Aristotele", grab_f3, drop_f3, grab_f1, drop_f1)
;;

