(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* Some concurrent object-oriented priority queue *) 

def min <<x,y>> = reply if x < y then x else y to min
def max <<x,y>> = reply if x > y then x else y to max

let create <<>> =

  def empty<<>> | none<> =
 	 none<<>> | reply true to empty
  and empty<<>> | some<x,e,a,r> =
      	 some<<x,e,a,r>> | reply false to empty 
  and add<<x>>  | none<> =
       {| let e,a,r = create<<>> in some<<x,E,A,R>> |} | reply to add 
  and add<<x>>  | some(y,e,a,r) =
      {| a <<max <<x,y>>>> ;
           | some<<min<<x,y>>,E,a,R>> |} | reply to add
  and remove<<>>| some<<x,e,a,r>> =
        if e<<>> then none<<>> else some<<r<<>>,e,a,r>> |
        reply x to remove in

  none<<>> | reply empty,add,remove to create

let empty,add,remove = create <<>>

def retire <> = print_int (remove<<>>) ; retire <<>>

def gen <x,i> =
  if x <= i then {| add<<x>> ; gen<<x+1,i>> |}

let _ =
  {| {| gen<<0,10>> | gen <<100,110>>|} | retire<<>>


