let def new_fork! () =
  let def grab! () | free () = busy() | reply true to grab
  or grab! () | busy () = busy() | reply false to grab
  or drop() | busy () = free() in
  free() | reply grab,drop
;;

let def count! (x) =
  let def s(x) | check! () =
    if x <= 0 then {s(x) | reply false to check}
    else {s(x-1) | reply true to check} in
  s(x) | reply check
;;

let c = count (1000)
;;

let def philosopher (name,grab_l,drop_l,grab_r,drop_r) =
  let def think() =
    print_string("Thinking: ");
    print_string(name);
    print_newline();
    hungry()
  or hungry() =
    if grab_l () then {
      if grab_r () then {eat()}
      else {drop_l() | hungry()}
    } else {hungry()}
  or eat() =
    if c () then {
      print_string("Eating: ");
      print_string(name);
      print_newline();
      think() | drop_l() | drop_r()}
    else { drop_l() | drop_r()} in
  think()
;;

spawn
  {let grab_f1,drop_f1 = new_fork ()
  and grab_f2,drop_f2 = new_fork ()
  and grab_f3,drop_f3 = new_fork () in
  philosopher ("Platone", grab_f1, drop_f1, grab_f2, drop_f2) |
  philosopher ("Socrate", grab_f2, drop_f2, grab_f3, drop_f3) |
  philosopher ("Aristotele", grab_f3, drop_f3, grab_f1, drop_f1)}
;;


