(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* computes fibonacci in a inefficient way *)

let def fib ! (x) =
  reply if x <= 1 then 1 else fib (x-1) + fib  (x-2) 

(* computes fibonnaci in a slighty better way (tail-recursion) *)

let def better_fib ! (n) = 
  let def fib2 ! (n) = 
    if n <= 1 then reply (1,1)
    else {let x,y = fib2 (n-1) in 
              reply  (x+y,x) } in
  let x,y = fib2  (n) in
  reply x

(* prints two equal numbers *)

let _ =
  print_int (better_fib  (20));
  print_newline ();
  print_int (fib  (20));
  print_newline ();
  print_string(" ") 



