(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

let def triple ! (x,y,z) =
  let def  get ! () =   reply (x,y,z) in
  reply get

let def new_cons ! (h,t) =
  let def head ! () = reply h to head
  and tail ! () =  reply t to tail
  and null ! () =  reply false to null in
  reply triple  (null,head,tail) to new_cons
and new_nil ! () =
  let def  head ! () = reply failwith "head of nil" to head
  and  tail ! () = reply failwith "tail of nil" to tail
  and  null ! () =  reply true to null  in
  reply triple  (null,head,tail) to new_nil

let def iter! (f,l) =

  let def iter'(lst) =
    let (n,hd,tl) = lst  () in
    if n  () then {fini' ()}
    else {f (hd  ()) ; iter'(tl  ())}
  and fini' () | k! () = reply to k in

  iter'(l) | k () ; reply to iter

let def map ! (f,lst) =
  reply
    let n,hd,tl = lst  () in
    if n  () then new_nil  ()
    else new_cons  (f  (hd  ()),map  (f,tl  ()))
  to map

let def print_int ! (x) = Join.print x ; print_string " " ; reply to print_int

let def fib ! (n) = reply if n <= 1 then 1 else fib (n-1) + fib (n-2) to fib
let def succ ! (n) = reply 1+n to succ

let def inter ! (x,i) =
reply
  if x < i then new_cons  (x,inter (x+1,i)) else new_nil  ()
to inter

let l = inter  (0,10)

let _ =
  iter  (print_int,map  (fib,map (succ,l))) ;
  iter  (print_int,l)
;;
