(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

let def plus(x,y,k) = k(x+y)

let def moins(x,y,k) = k(x-y)

let def inf(x,y,k) = k((x <= y))

let def if'(b,kt,kf) = if b then {kt()} else {kf()}

let def fib(x,k) =
  let def kt() = k(1)
  and kf() =
    let def k1(r1) =
      let def k2(r2) = plus(r1,r2,k) in
      let def k0(a) = fib(a,k2) in
      moins(x,2,k0) in
    let def k0(a) = fib(a,k1) in
    moins(x,1,k0) in
  let def kinf(b) = if'(b,kt,kf) in  
  inf(x,1,kinf)


let def print(r) = Join.print r ; print_newline ();
;;

spawn { fib(10,print)}
;;
Join.server ()

