(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* test local des locations et des primitives go, halt, fail *)

open Join

let def wait! n | tick () =
  (if n >0 then wait (n-1));
  reply to wait 

let def emptyloc! name = 
  let loc a 
    with dump! s =
           print_string name ;
           print_string s;
           print_newline () ;
           reply to dump
     and s () = 
           dump "halting"; 
           halt ();
     and always n = 
           if n < 5000 then {
           print_string name;
           print n; 
           print_newline () ;
           { always (n+1) | tick () }}
    = struct spawn {  always 0 }
    end in 
  let def stop! () = s () | { fail a; 
                         reply to stop } in
  dump "create" ;
  reply a,stop to emptyloc 

let def movingloc! () = 
  let loc a
    with move! b = print_string "moving"
                  ; print_newline ()
                  ; go b
                  ; print_string "arrived"
                  ; print_newline ()
                  ; reply to move
      = struct 
        let m,stop_m = emptyloc "m " in
        print_string "started movingloc";
        print_newline () ;
        fail m;
        print_string "submoving loc has failed";
        print_newline ()
      end in 
  reply move to movingloc 
 
let x,stop_x = emptyloc "x "
let y,stop_y = emptyloc "y "

let m = movingloc ()

let _ = spawn {
  wait 10;
  m x;
  wait 10;
  m y;
  stop_x () ;
  wait 10;
  stop_y () ;
  { tick() | tick() | tick() | tick() |
    { wait 4;
      print_string "leaving";
      print_newline ();
      } }
} 








