(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* arrays *)
let t = Array.create 10 "x"

let _ = Array.set t 5 "X"

let array_iter <j,max> =
  { if j >= max then {fini <<>>}
  else {
    print_string(Array.get t j) ;
    array_iter<<j+1,max>>
  }
  } 
and  fini <> | wait <<>> = reply to wait

let _ = spawn { array_iter <<0,Array.length(t)>> }

let _ =wait <<>> ; print_newline ()

let s = String.make 10 (String.get "a" 0)

let _ =print_string(String.escaped (s^"\n")^"\n")

(* lists *)
open List

let cons (hd, tl) = hd::tl
let consp = function [] -> false | _ -> true
let nil = []

let l = cons(1,cons(2,nil))

let ll = flatten (cons(l,cons(l,nil)))

let lp = combine ll ll

let l1,l2 = split(lp)

let l = l1@l2

let list_iter<l> =
  if consp(l) then {
    print_int(hd(l)) ;
    list_iter<<tl(l)>>
  } else {
    fini<<>>
  }
and fini <> | wait <<>> = reply to wait
let _ = spawn { list_iter<<rev(l)>> }

let _ =wait <<>> ; print_newline ()

(* list and string *)

let s = String.concat ", " (cons("1",cons("2",nil)))

let _ =print_string(s) ; print_newline ()


(* list and array *)
let a = Array.create 10 "coucou\n"
let la = cons (a,cons(a,cons(a,nil)))
let b = Array.concat(la)
let _ =
  let l = Array.length(b) in
  print_string ((Array.get b 0)^(Array.get b (l-1)))


(* floats *)
let x = float_of_string("1.0")

let _ = print_float(exp(x) +. log(x)) ; print_newline()

