(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

let def compteur! (v0) =

  let def get ! () | s(v) =
    { s(v) | reply v }
  or incr ! () | s(v) =
    { s(v+1) | reply () } in

  s(v0) | reply (get,incr)

let get,set = compteur (0)

let def new_incr ! (f_top) =
  let def incr (x) =
    if x < 0 then {f_top ()}
    else
      {set () ;
         let i1 = new_incr  (f1)
         and i2 = new_incr  (f2) in
         i1 (x-1) | i2 (x-2) }
  or f1 () | notYet () = dOne ()
  or f2 () | notYet () = dOne()
  or f1 () | dOne () = f_top()
  or f2 () | dOne () = f_top() in

  notYet () | reply incr

let def new_read ! () =
  let def read () | l () =
     l() | { print_int (get  ()) ; print_string "/"; read ()}
  or f () | l () = {print_newline();} in
  l () | reply read,f

;;
spawn {
  let read,f = new_read  () in
  let incr = new_incr  (f) in
  read () | incr (5) 
} 
;;
