(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

let def create ! () =

  let def empty! () | none() =
      { none() |
        reply true to empty }
  or empty! () | some(x,e,a,r) =
      { some(x,e,a,r) |
        reply false to empty }
  or push! (x)  | none() =
      { {let e,a,r = create () in
        some(x,e,a,r)} | reply to push}
  or push! (x)  | some(y,e,a,r) =
       a (y) ; some(x,e,a,r)  | reply to push
  or remove! ()| some(x,e,a,r) =
      if e () then {none()} else {some(r (),e,a,r)} |
        reply x to remove in

  none() |
  reply empty,push,remove to create

let empty,add,remove = create  ()

let def retire ! () = Join.print(remove ())  ;  retire  () ; reply to retire

let def gen ! (x,i) =
  if x > i then {reply to gen}
  else {add (x) ;  gen (x+1,i) ; reply to gen}

;;
spawn
  { {gen (0,2) ; } | {gen  (100,102) ; } | { retire () ;} }
;;



 
