(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* applet-server.j :

   provides an applet with some internal state,
   and remotely logs its usage *)

let load_applet(client,name) = 

  let log(s) = 
    print_string(name^" applet reports "^s);
    print_newline ();
    reply in

  loc applet
    with get() | some(x) = log("empty"); none() | reply x to get
    and  put(x) | none() = log("full"); some(x) | reply to put
    init 
    go(client); none ()
  end in

  reply get,put

do shutdown.ready()
do ns.register ("applet",load_applet)




