(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* a distributed test for halt/fail and migration.
   repeatedly creates triples of nested locations *)

do shutdown.ready()

let make_loc (n,a,b) =
  loc local 
  with 
    pr(s) = print(n);print_string(s); print_newline (); reply
  init
    pr(" start  "); go(a); 
    pr(" middle "); go(b);
    pr(" end    "); halt()
  end in 
  fail(local);print(n);print_string(" halt   "); print_newline ();
| reply local

loc here end
let there = ns.lookup("server")
(* loc there end *)

let do_it (n) =
  let u = make_loc (n,here,there) in
  let v = make_loc (n+1,there,here) in
  (* let w = make_loc (n+2,u,v) in fail(w) ; *)
  fail(v); fail(u); 
  if n < 2000 then { do_it (n+100) } else { shutdown.global() }
  
spawn do_it(1000)



