(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

do shutdown.ready()

let fib (x,d) =
  reply ( if x <= 2 then 1 else fib(d(x),d) + fib(d(d(x)),d) ) to fib 

let Done() | None() = Some() 
and Done() | Some() = shutdown.global()
spawn None()

let Do(n,title,decr) =
  let f = fib(n,decr) in
  print_string(title); print(n);
  print_string(" is "); print(f); print_newline ();
  if n<10 then { Do(n+1,title,decr) } else { Done() }

let local_decr (x) = reply x-1
let remote_decr = ns.lookup("decr") 

spawn Do(1,"remote fib of ",remote_decr) 

spawn Do(1,"local fib of  ",local_decr)


