(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* this example uses the binary decomposition of integers
   to generate invocation stacks *)

do shutdown.ready()

loc loc_f 
  with f(n,l) = { 
    print_string ("f -> ");
    print (n);
    print_newline () ;
    if n = 0 then { 
      print_string ("f moves out"); print_newline ();
      go(l);
      print_string ("f arrives"); print_newline ();
      reply 0 to f }
    else {
      let d = n/2 in
      let r = n - 2*d in
      let v = (if r=0 then 2*f(d,l) else 2*g(d,l)+1) in
      print_string ("f <- ");
      print (v);
      print_newline () ;
      reply v to f }}    
    init print_string ("running location f\n"); end

and loc_g 
  with g(n,l) = {
    print_string ("g -> ");
    print (n);
    print_newline () ;
    if n = 0 then {
      print_string ("g moves out"); print_newline ();
      go(l);
      print_string ("g arrives"); print_newline ();
      reply 0 to g }
    else { 
      let d = n/2 in
      let r = n - 2*d in
      let v = (if r=0 then 2*f(d,l) else 2*g(d,l)+1) in
      print_string ("g <- ");
      print (v);
      print_newline () ;
      reply v to g }}
    init null () end 

and c init print_string("running client\n");  end 

let s  = ns.lookup("server") 

let n1 = 1+    4+  8 
let n2 = 1+ 2+ 4+ 16 

spawn
  print (f(n1,s)); print_newline () ; 
  print_string ("done") ; print_newline () ;  
  print (f(n2,s)) ; print_newline () ;  
  print_string ("done") ; print_newline () ;
  shutdown.global()


(*
let Loop (n,s,c) = {
  print (f(n,s)) ; print_newline () ;
  print_string ("done") ; print_newline () ;  
  dump_locations () ;
  Loop (n+1,c,s) } in

Loop (1,s,c) *)


