(***********************************************************************)
(*                                                                     *)
(*                     the join-calculus language                      *)
(*                                                                     *)
(*   Cedric Fournet and Luc Maranget, projet PARA, INRIA Rocquencourt  *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

do shutdown.ready()

let limit = 10

let busy() | serial() = serial() | reply to busy

spawn serial()

let make_it (name,place1,place2) =
  loc agent
    with pair() = reply agent,name
     and log(action) = 
       print_string(name^" "^action); print_newline();reply
     and travel(n,p1,p2) =
      let here,name_here = p1() in
      log("is going to "^name_here);
      go(here); 
      log("arrives in "^name_here);
      busy();
      if n>0 then { travel(n-1,p2,p1) } else { log("stops moving");halt() }
    init travel(limit,place1,place2) end in 
  reply pair

let make_it_simple(name,place) =
  loc simple init 
    go(place);print_string(" *** this is "^name^" *** ");print_newline();
  end in
  let pair() = reply place,name in reply pair
  

let here = loc here end in make_it_simple("Rocquencourt",here)
let there = make_it_simple("Paris",ns.lookup("server"))
  
let train = make_it("the train",here,there)
let car = make_it("the bus",train,there)
let alice = make_it("Alice",here,car)
let bob = make_it("Bob",car,train)

spawn 
  let a,n = train() in 
  fail(a);shutdown.global()






