(* philo.ml: some philosophers at dinner					*)

let _ = Debug.flag := false

let sleep n = 
  for i=0 to n*1000 do
    ()
  done

let new_fork<<>> = 
  let grab<<>> | free<> =  busy<<>> | reply true
  or grab<<>> | busy<> =  busy<<>> | reply false
  or drop<> | busy<> =  free<<>>
  in  free<<>> | reply (grab, drop)

let philosopher<name, grab_l, drop_l, grab_r, drop_r> = 
  let think<> = 
    print_string("Thinking: ");
    print_string(name);
    print_newline ();
    sleep(Random.int 20);
    hungry<<>>
  or hungry<> =  
    if grab_l<<>> then
      if grab_r<<>> then
        eat<<>>
      else 
      {  drop_l<<>> | think<<>> }
    else
      think<<>>
  or  eat<> =  
    print_string("Eating: ");
    print_string(name);
    print_newline ();
    sleep(Random.int 20);
    think<<>> | drop_l<<>> | drop_r<<>>  
  in think<<>>
  ;;

				
spawn { 
  let grab_f1,drop_f1 = new_fork<<>>
  and grab_f2,drop_f2 = new_fork<<>>
  and grab_f3, drop_f3 = new_fork<<>>
  in
  philosopher<<"Platone", grab_f1, drop_f1, grab_f2, drop_f2>> |
  philosopher<<"Socrate", grab_f2, drop_f2, grab_f3, drop_f3>> |
  philosopher<<"Aristotele", grab_f3, drop_f3, grab_f1, drop_f1>>
} 

;;
Join.suspend ()

