let debug = try Sys.getenv "JDEBUG"  with Not_found -> ""

let flags = Array.create 256 (debug = "-")

let _ =
  for i = 0 to (String.length debug)-1 do
    flags.(Char.code debug.[i]) <-  true;
  done

external prerr_string : string -> unit = "prerr_string"
open Printf

let print0  c f =
  if flags.(Char.code c) then
    prerr_string (sprintf f)
let print1  c f x =
  if flags.(Char.code c) then
    prerr_string (sprintf f x)
let print2 c f x y =
  if flags.(Char.code c) then
    prerr_string (sprintf f x y)
let print3 c f x y z =
  if flags.(Char.code c) then
    prerr_string (sprintf f x y z)
let print4 c f x y z w =
  if flags.(Char.code c) then
    prerr_string (sprintf f x y z w)

let f c g  = if flags.(Char.code c) then g ()

let trap c s g =
  if flags.(Char.code c) then
    try
      g ()
    with
      e ->
        prerr_string (sprintf "Exception %s in %s" (Printexc.to_string e) s);
        raise e
  else
    g ()

let print s =  print1 'a' "%s\n" s
