#ifndef JOIN_H
#define JOIN_H

#include "threads.h"
#include "mlvalues.h"

/* Jtypes.locator */
#define LOCATOR_AGE      0
#define LOCATOR_DISTANCE 1
#define LOCATOR_ID       2
#define LOCATOR_OTYPE    3
#define LOCATOR_SIZE     4

/* Types.local_automata */
#define AUTOMATA_STATE     0
#define AUTOMATA_NTESTS    1
#define AUTOMATA_PATTERNS  2
#define AUTOMATA_PROCESSES 3
#define AUTOMATA_BUFFERS   4

/* Types.scion_id */
#define ID_LOCATION     0
#define ID_AUTOMATA     1
#define ID_THREAD       2
#define ID_RELOC        3

/* Marshalled thread */ 	
#define THREAD_LOCATION       0
#define THREAD_TRAP_OFFSET    1 
#define THREAD_STACKTHRESHOLD 2
#define THREAD_STACKSIZE      3
#define THREAD_STATUS         4
#define THREAD_SYNC           5
#define THREAD_JOINING        6
#define THREAD_MARSH_SIZE     7

typedef struct reloc_module     *reloc_module_t;
typedef struct def_stub         *def_t;
typedef struct local_def_struct *local_def_t;

struct reloc_module {
  value    module_name;
  value    module_slot;
  value    module_code_offset;
  value    module_code_len;
  value    module_code_begin;
  value    module_code_end;
  value    module_reloc;
  value    module_bytecode;
  value    module_interface;
  value    module_exceptions;
  value    module_migrate;
  value    module_data[1];     /* some local data */ 
};

#define STATE_SIZE  3
#define LDEF_OFFSET 2
#define LDEF_NTESTS Int_val(Field(ldef,1))
#define LDEF_STATE  Field(ldef,0)
#define LDEF_PATTERN(ldef,i)   Field(ldef,LDEF_OFFSET+STATE_SIZE*i)
#define LDEF_PROCESS(ldef,i)   Field(ldef,LDEF_OFFSET+1+STATE_SIZE*i)
#define LDEF_THREAD(ldef,i)    Field(ldef,LDEF_OFFSET+2+STATE_SIZE*i)
#define LDEF_ARGS(ldef,i)      Field(def,LDEF_OFFSET+ \
				     STATE_SIZE*LDEF_NTESTS(ldef)+i)
struct local_def_struct {
  value state;
  value ndefs;
  value patterns[1];
};

/* Types.stub */
#define STUB_LOCATOR 0
#define STUB_POS     1
#define STUB_LOCAL   2
#define STUB_RESERV  3
#define STUB_STUB    4
#define STUB_SIZE    5
struct location_stub {
  value*           locator1;
  value            space;
  local_location_t lloc;
  value            reserv;
  value            stub;
};

struct def_stub {
  value*           locator1;
  value            loc;
  local_def_t      ldef;
  value*           reserv;
  value            stub;
};

struct thread_stub {
  value*           locator1;
  value            loc;
  thread_t         lthread;
  value           reserv;
  value            stub;
};


#define DEF_WEAKSET_SIZE 2000
#define LOC_WEAKSET_SIZE 20

#include "modules.h"

#endif
