
(* jstuff.c
external init_space : unit -> unit = "init_space";;
external new_space_threshold : unit -> int = "new_space_threshold";;
external get_space_threshold : int -> int = "get_space_threshold";;
external free_space_threshold : int -> unit = "free_space_threshold";;

external new_stub_ts : int -> stub_ts = "new_stub_ts";;
external set_stub_ts : int -> int -> unit = "set_stub_ts";;
*)

value threshold_table;
value threshold_table_size;
#define INITIAL_THRESHOLD_TABLE 100

value init_space(value unit) /* ML */
{
  value i;

  threshold_table = (value)stat_alloc(INITIAL_THRESHOLD_TABLE*sizeof(value));
  threshold_table_size = INITIAL_THRESHOLD_TABLE;
  for(i=0;i<threshold_table_size;i++)
    Field(threshold_table,i) = 0;
  
  return Val_unit;
}

value new_space_threshold(value unit) /* ML */
{
  value i;

  for(i=0;i<threshold_table_size;i++)
    if(Field(threshold_table,i) == 0){
      Field(threshold_table,i) = Val_int(0);
      return Val_int(i);
    }
  threshold_table = (value) stat_resize ( (char*)threshold_table, 
					  threshold_table_size * 2);
  for(i=threshold_table_size;i<2*threshold_table_size;i++)
    Field(threshold_table,i) = 0;
  threshold_table_size *=2;

  return Val_int(threshold_table_size/2);
}

value get_space_threshold(value space_threshold) /* ML */
{
  return Field(threshold_table,Int_val(space_threshold));
}

value free_space_threshold(value space_threshold) /* ML */
{
  Field(threshold_table,Int_val(space_threshold)) = (value)0;

  return Val_unit;
}

void finalize_stub(value stub_ts)
{
  if(Field(threshold_table,Int_val(Field(stub_ts,1))) < Field(stub_ts,2))
    Field(threshold_table,Int_val(Field(stub_ts,1))) = Field(stub_ts,2);

  return;
}

value new_stub_ts(value space_threshold) /* ML */
{
  value res = (value)alloc_final(3,finalize_stub,1,32);

  Field(res,1) = space_threshold;
  Field(res,2) = Val_int(0);

  return res;
}

value set_stub_ts(value stub_ts,value ts) /* ML */
{
  if(ts>Field(stub_ts,2)) Field(stub_ts,2) = ts;
  return Val_unit;
}
  /*
  sz = 12 + 5 * nchans + 2 * ndefs;
  DPRINT1("Allocation def : %d\n",sz);
  block = (value*)alloc(sz,ID_AUTOMATA);
  for(i=0;i<sz;i++) Field(block,i) = Val_unit;
  h = Hd_val(block);
  color = Color_hd(h);

  location = curr_thread->location;
  lloc = location->lloc;
  
  id = (value)block;
  header = (header_t *)Hp_val(id);
  *header = Make_header(2,ID_AUTOMATA,color);
  Assign(Field(id,0),location->id);
  Assign(Field(id,1),lloc->counter);
  lloc->counter = Val_int(Int_val(lloc->counter)+1);
  
  block += 3;
  sz =  2 + 2 * ndefs + nchans;
  ldef = (value) block;
  header = (header_t *)Hp_val(ldef);
  *header = Make_header(sz,Local_tag,color);
  Field(ldef,1) = ndefs_v;

  block += sz+1;
  def = (value)block;
  header = (header_t *)Hp_val(def);
  *header = Make_header(3,Automata_tag,color);
  Assign(Field(def,STUB_ID),id);
  Assign(Field(def,STUB_POS),location);
  Assign(Field(def,STUB_LOCAL),ldef);

  block += 4;
  res = (value)block;
  header = (header_t *)Hp_val(res);
  *header = Make_header(1+nchans,0,color);
  Assign(Field(res,0),def);

  block += 2+nchans;
  for(i=0;i<nchans;++i){
    chan = (value)(block + 3*i);
    header = (header_t *)Hp_val(chan);
    *header = Make_header(2,0,color);
    Assign(Field(chan,0),def);
    Field(chan,1) = Val_int(i);
    Assign(Field(res,i+1),chan);
  }

  Begin_roots2(res,lloc);
  
  tmp = weakset_add(lloc->def_weakset,def);
  Assign(lloc->def_weakset,tmp);

  End_roots();
  */
