open Jtypes
open Metatype

exception TypeMismatch of mtype_expr

let setLocalService name (object:'a) (vt:'a metatype) =
  let vt = Obj.repr vt in
  Jprims.critical_section (function () ->
    Hashtbl.add Space.name_server name ((Obj.repr object),vt);
    )

let getLocalService name (vt:'a metatype) =
  let (o,t) =
    Obj.magic (
    Jprims.critical_section   (function () ->
      Hashtbl.find Space.name_server name))
  in
  let ty = translate t in
  if le (translate vt) ty then
    (o:'a)
  else
    raise (TypeMismatch ty) 

let getRemoteService space_id name (vt:'a metatype) =
  Jprims.critical_section (fun () ->
    let space = Space.get_space space_id in
    Debug.print "get 2";
    Space.send space
      (let t =
         Jmarshal.marshal space (GetService (name,(Obj.repr vt), 
                                               Jprims.self_stub ()))
      in
      t);
    Debug.print "get 3";
    match Jprims.wait_on_stub () with
      Reply v -> (Obj.magic v:'a)
    | Exception e -> raise e
          )

let getSpaceService addr port service =
  let space_id = Space.first_connect_to (addr,port) in
  getRemoteService space_id service
