(***********************************************************************)
(*                                                                     *)
(*                    ______________                                   *)
(*                                                                     *)
(*      Fabrice Le Fessant, projet SOR/PARA INRIA Rocquencourt         *)
(*                                                                     *)
(*                 mail: fabrice.le_fessant@inria.fr                   *)
(*                 web:  http://www-sor.inria.fr/~lefessan             *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(*                                                                     *)
(***********************************************************************)

(*         File written in the Objective-CAML language                 *)

let file name = 
  let nsdir =
    try
      Sys.getenv "JOINNSDIR"
    with
      Not_found -> 
        try
          Sys.getenv "HOME"
        with
          Not_found -> "/tmp/"
  in
  Filename.concat nsdir (".join-"^name)

let register name =
  let oc = open_out (file name) in
  output_value oc Space.local_id;
  flush oc;
  close_out oc


let query name =
  let ic = open_in (file name) in
  let space_id = input_value ic in
  close_in ic;
  (space_id : Join.space_id)
