open Join
open Unix
open ThreadUnix

let ns_server_port =
  try
    int_of_string (Sys.getenv "JNSPORT")
  with
    _ -> 20001

let ns_server_name =
  try
    Sys.getenv "JNSNAME"
  with
    Not_found -> gethostname ()

let ns_server_addr = (gethostbyname ns_server_name).h_addr_list.(0)

let (ns_lookup,ns_register) = (ref (fun () -> failwith ""),
                               ref (fun () -> failwith ""))
let init start =
  let ((ns_lookup_chan:string * Obj.t  => Obj.t),
       (ns_register_chan:string * Obj.t * Obj.t => unit)) = 
    let rec connect start =
      try
        getSpaceService ns_server_addr ns_server_port "NS_SERVER" vartype
      with
        e -> 
          if start && ns_server_name = gethostname () then begin
            Sys.command "jocns";
            sleep 1;
            connect false
          end else raise e
    in
    connect start
  in
  ns_lookup := (fun () -> ns_lookup_chan);
  ns_register := (fun () -> ns_register_chan)
  
let _ =
  ns_lookup := (fun () -> init false; !ns_lookup ());
  ns_register := (fun () -> init true; !ns_register ())
     
let (lookup: string -> 'a metatype -> 'a) = 
  fun resource_name resource_type ->
    Obj.magic ((!ns_lookup ()) (resource_name,Obj.repr resource_type))

let (register: string -> 'a -> 'a metatype -> unit) =
  fun resource_name resource resource_type ->
    (!ns_register ()) (resource_name,Obj.repr resource,Obj.repr resource_type)

