open Join

let port =
  try
    int_of_string (Sys.getenv "JNSPORT")
  with
    _ -> 20001

let def lookup! (resource_name,(resource_type:Obj.t)) =
  Debug.print1  'n' "Lookup: %s\n" resource_name;
  reply Obj.repr (
  try getLocalService ("ext_"^resource_name) 
                    (Obj.magic resource_type)
  with
    Not_found -> Debug.print0 'n' "unbound resource\n";
      raise Not_found
      )
and register! (resource_name,(resource:Obj.t),(resource_type:Obj.t)) =
  Debug.print1 'n' "Register: %s\n" resource_name;
  setLocalService ("ext_"^resource_name) 
    (Obj.magic resource) 
    (Obj.magic resource_type);
  reply ()

let _ = 
  Printexc.print 
    (fun () -> 
      new_port port;
      setLocalService "NS_SERVER" (lookup,register) vartype;
      server ()) ()
