let debug = try Sys.getenv "JDEBUG"  with Not_found -> ""

let flags = Array.create 256 (debug = "-")

let _ =
  for i = 0 to (String.length debug)-1 do
    flags.(Char.code debug.[i]) <-  true;
  done
open Printf

let print0  c f =
  if flags.(Char.code c) then
    (fprintf stderr "%s" (sprintf f); flush stderr)
let print1  c f x =
  if flags.(Char.code c) then
    (fprintf stderr "%s" (sprintf f x); flush stderr)
let print2 c f x y =
  if flags.(Char.code c) then
    (fprintf stderr "%s" (sprintf f x y); flush stderr)
let print3 c f x y z =
  if flags.(Char.code c) then
    (fprintf stderr "%s" (sprintf f x y z); flush stderr)
let print4 c f x y z w =
  if flags.(Char.code c) then
    (fprintf stderr "%s" (sprintf f x y z w); flush stderr)
let f c g  = if flags.(Char.code c) then g ()

let trap c s g =
  if flags.(Char.code c) then
    try
      g ()
    with
      e ->
        fprintf stderr "Exception %s in %s" (Printexc.to_string e) s;
        raise e
  else
    g ()

let print s =  print1 'a' "%s\n" s
